#include "obr.h"  

void Picture::load() {
  FILE *f = fopen(fileName.c_str(),"r"); 
  assert ( f );
  pic = gdImageCreateFromPng(f);
  fclose(f);
} 


void Picture::save() {
  FILE *out = fopen(fileName.c_str(),"w"); 
  gdImagePng(pic,out);
  fclose(out);
} 

void Picture::show() {
  string cmd = "xv "+fileName+"&"; 
  system(cmd.c_str());
} 

void Picture::create(const vector<Pixel>& palette, Picture& img) {

  if (pic)
    gdImageDestroy(pic); 

  pic = gdImageCreate(img.getXSize(), img.getYSize());

  // create given palette 
  for (unsigned i = 0; i < palette.size(); i++)
    gdImageColorAllocate( pic,  palette[i].r, palette[i].g, palette[i].b );

  // copy img 
  Pixel pix;  int c; 
  for (int i=0; i<img.getXSize(); i++)
    for (int j=0; j<img.getYSize(); j++) {
      pix = img.getPixel(i,j);
      c = gdImageColorClosest( pic, pix.r, pix.g, pix.b);
      gdImageSetPixel(pic, i, j, c);
    } 
}   
