#include "gd.h" 
#include <string>
#include <vector> 
#include <iostream>   
#include <math.h>

using namespace std;

class Pixel {
public:
  // RGB values, 0..255
  int r;  
  int g;
  int b; 

  double distanceFrom(const Pixel& p) { // vzdalenost od p (na druhou) 
    double d = 0;
   
    d += (r - p.r)*(r-p.r); 
    d += (g - p.g)*(g-p.g); 
    d += (b - p.b)*(b-p.b);

    //    return d;
    return sqrt(d); 
  }

  void normalize() {
    if (r < 0) r = 0; else if (r>255) r = 255;
    if (g < 0) g = 0; else if (g>255) g = 255;
    if (b < 0) b = 0; else if (b>255) b = 255;
  }
    

  //  int getColor() { return gdImageTrueColor(r,g,b); } chyba v manualu knihovny !
}; 

class Picture {

public:
  Picture() { pic = NULL; } 

  void setFileName(const string& _fileName) { fileName = _fileName; }
  void load(); 
  void show(); 
  void save(); 

  // create new picture using the given palette and source image
  void create(const vector<Pixel>& palette, Picture& img);  

  bool trueColor() { return pic->trueColor; }

  int getXSize() { return gdImageSX(pic);}; 
  int getYSize() { return gdImageSY(pic); };  

  Pixel getPixel(int x,int y) {
    Pixel p; int c = gdImageGetPixel(pic,x,y);
    p.r = gdImageRed(pic,c); p.g = gdImageGreen(pic,c); p.b = gdImageBlue(pic,c);
    return p; 
  } 
 
  void setPixel(int x,int y,Pixel p) { 
    if (trueColor()) 
      throw 1; //
      //      gdImageSetPixel(pic, x,  y,  p.getColor());
    else {
      int c = gdImageColorExact(pic, p.r, p.g, p.b);
      if (c == -1) { cout << "Color not allocated." << endl; 
      return;
      }
      gdImageSetPixel(pic, x,  y, c);
    }
  };

  
private:
  int pallete; 
  string fileName;
  gdImagePtr pic; 
}; 


